#include <avr/interrupt.h>
#include <avr/signal.h>
#include"usart.h"

short ausgang;
short tmp;
short keypressold;
short keypresscount;

volatile short count;


int keypadread(void)
{
	asm volatile ("nop"::);
	
	short keypress = PINA;
	
	char str[10];
	sprintf(str,"%c\r\n",keypress);
	USART_String(str);
	
	if ((keypress>>3)==0)
	{
		count++;
		return 0;
	}
	
	if (keypress==keypressold)
	{
		keypresscount++;
	}
	keypressold = keypress;
	
	// Damit im Timerinterrupt der nchste Ausgang gesetzt wird
	if (keypresscount == 3)
	{
		keypresscount=0;
		count++;							
		switch (keypress)
		{
			case 0x09:
				USART_String("Taste 1\n");
				break;
			case 2:
				USART_String("Taste 4\n");
				break;
			case 4:
				USART_String("Taste 7\n");
				break;
			case 8:
				USART_String("Taste *\n");
				break;
		}
	}
	return 0;
}


SIGNAL (SIG_OVERFLOW1) 
{
	char str[10];
	
	if (count==0)
	{
		PORTA = (1<<DDA0);
		count++;
		USART_String("Port 1 - ");
		sprintf(str,"%d\r\n",count);
		USART_String(str);
		return;
	}
	if (count==1)
	{
		keypadread();
		return;
	}
	if (count==2)
	{
		PORTA = (1<<DDA1);
		USART_String("Port 2\r\n");
		count++;
		return;
	}
	if (count==3)
	{
		keypadread();
		return;
	}
	if (count==4)
	{
		PORTA = (1<<DDA2);
		USART_String("Port 3\r\n");
		count++;
		return;
	}
	if (count==5)
	{
		keypadread();
		return;
	}
	count=0;
	return;
}

SIGNAL (SIG_UART_TRANS) 
{
	return;
}

SIGNAL (SIG_UART_RECV) 
{
	return;
}

int main(void)
{
	// Serielle Schnittstelle initialisieren
	USART_Init();
	
	// Timer initialisieren
	TIMSK = _BV(TOIE1);            		//Timer Overflow Interrupt enable
	TCNT1 = 0;                			//Rcksetzen des Timers
	TCCR1B = _BV(CS11)|_BV(CS10);		//Prescaler 8 -> 7,6 Hz = 130ms
	
	
	// Die Ausgnge werden deklariert.
	DDRA=(1<<DDA0)|(1<<DDA1)|(1<<DDA2);
	
	// Testausgang fr den Compiler
	DDRB=(1<<DDB0)|(1<<DDB1);
	
	USART_String("Start...\r\n");
	
	sei ();
	
	for(;;)
	{
	}
	return 0;
}
